;Low resolution graphics in M/L
;In the page 111 of the book linked below
;has a very fast LM routine for PLOT/UNPLOT:
;http://www.zx81.megahospedagem.com.br/files/p81/livros/ulm.zip
;The book is in portuguese language, but the
;routine is ready for use.  
;Before call it, set the registers B and C with X and Y,
;respectivelly, and set register A with $40 for 
;PLOT, or with $00 for UNPLOT.

ORG 4084

@DFILE=400C

@FASTPLOT
	PUSH BC
	PUSH HL
	PUSH DE
	PUSH AF
	LD A,87
	BIT 0,B
	JR NZ +2
	ADD A,10
	BIT 0,C
	JR Z +2
	ADD A,08
	LD D,A
	POP AF
	PUSH AF
	ADD A,D
	LD (PLOT+1),A
	SRL B
	SRL C
	LD HL,(DFILE)
	INC HL
	LD D,00
	LD E,C
	ADD HL,DE
	LD A,15
	SUB B
	LD B,A
	JR Z +6
	LD DE,21
	ADD HL,DE
	DJNZ -3
	LD A,(HL)
	CP 08
	JR C +1
	CPL
@PLOT
	SET 00,A		;00=SR SET/RES X,A
	BIT 3,A
	JR Z +5
	CPL
	AND 8F		;Typo in listing AND A,130 should be AND A,143
			;the opcode is correct  E68F
	JR +2
	AND 0F
	LD (HL),A
	POP AF
	POP DE
	POP HL
	POP BC
	RET 